Index: Makefile
===================================================================
--- Makefile	(revision 91acc76394a343d03d0bba7436abee0fb39d98b6)
+++ Makefile	(revision 48276998dc10a603d04dfcaf34cbf97b78a7a634)
@@ -137,4 +137,15 @@
 tmp/examples/Example1.$(ObjSuf): \
 	examples/Example1.cpp \
+	classes/DelphesClasses.h \
+	external/ExRootAnalysis/ExRootTreeReader.h \
+	external/ExRootAnalysis/ExRootTreeWriter.h \
+	external/ExRootAnalysis/ExRootTreeBranch.h \
+	external/ExRootAnalysis/ExRootResult.h \
+	external/ExRootAnalysis/ExRootUtilities.h
+Validation$(ExeSuf): \
+	tmp/examples/Validation.$(ObjSuf)
+
+tmp/examples/Validation.$(ObjSuf): \
+	examples/Validation.cpp \
 	classes/DelphesClasses.h \
 	external/ExRootAnalysis/ExRootTreeReader.h \
@@ -150,5 +161,6 @@
 	root2pileup$(ExeSuf) \
 	stdhep2pileup$(ExeSuf) \
-	Example1$(ExeSuf)
+	Example1$(ExeSuf) \
+	Validation$(ExeSuf)
 
 EXECUTABLE_OBJ +=  \
@@ -159,5 +171,6 @@
 	tmp/converters/root2pileup.$(ObjSuf) \
 	tmp/converters/stdhep2pileup.$(ObjSuf) \
-	tmp/examples/Example1.$(ObjSuf)
+	tmp/examples/Example1.$(ObjSuf) \
+	tmp/examples/Validation.$(ObjSuf)
 
 DelphesHepMC$(ExeSuf): \
@@ -183,4 +196,17 @@
 	classes/DelphesLHEFReader.h \
 	external/ExRootAnalysis/ExRootTreeWriter.h \
+	external/ExRootAnalysis/ExRootTreeBranch.h \
+	external/ExRootAnalysis/ExRootProgressBar.h
+DelphesROOT$(ExeSuf): \
+	tmp/readers/DelphesROOT.$(ObjSuf)
+
+tmp/readers/DelphesROOT.$(ObjSuf): \
+	readers/DelphesROOT.cpp \
+	modules/Delphes.h \
+	classes/DelphesStream.h \
+	classes/DelphesClasses.h \
+	classes/DelphesFactory.h \
+	external/ExRootAnalysis/ExRootTreeWriter.h \
+	external/ExRootAnalysis/ExRootTreeReader.h \
 	external/ExRootAnalysis/ExRootTreeBranch.h \
 	external/ExRootAnalysis/ExRootProgressBar.h
@@ -200,4 +226,5 @@
 	DelphesHepMC$(ExeSuf) \
 	DelphesLHEF$(ExeSuf) \
+	DelphesROOT$(ExeSuf) \
 	DelphesSTDHEP$(ExeSuf)
 
@@ -205,4 +232,5 @@
 	tmp/readers/DelphesHepMC.$(ObjSuf) \
 	tmp/readers/DelphesLHEF.$(ObjSuf) \
+	tmp/readers/DelphesROOT.$(ObjSuf) \
 	tmp/readers/DelphesSTDHEP.$(ObjSuf)
 
@@ -344,4 +372,5 @@
 	modules/PdgCodeFilter.h \
 	modules/BeamSpotFilter.h \
+	modules/RecoPuFilter.h \
 	modules/Cloner.h \
 	modules/Weighter.h \
@@ -351,4 +380,5 @@
 	modules/VertexSorter.h \
 	modules/VertexFinder.h \
+	modules/VertexFinderDA4D.h \
 	modules/ExampleModule.h
 tmp/modules/ModulesDict$(PcmSuf): \
@@ -798,4 +828,13 @@
 	external/ExRootAnalysis/ExRootFilter.h \
 	external/ExRootAnalysis/ExRootClassifier.h
+tmp/modules/RecoPuFilter.$(ObjSuf): \
+	modules/RecoPuFilter.$(SrcSuf) \
+	modules/RecoPuFilter.h \
+	classes/DelphesClasses.h \
+	classes/DelphesFactory.h \
+	classes/DelphesFormula.h \
+	external/ExRootAnalysis/ExRootResult.h \
+	external/ExRootAnalysis/ExRootFilter.h \
+	external/ExRootAnalysis/ExRootClassifier.h
 tmp/modules/SimpleCalorimeter.$(ObjSuf): \
 	modules/SimpleCalorimeter.$(SrcSuf) \
@@ -896,4 +935,14 @@
 	modules/VertexFinder.$(SrcSuf) \
 	modules/VertexFinder.h \
+	classes/DelphesClasses.h \
+	classes/DelphesFactory.h \
+	classes/DelphesFormula.h \
+	classes/DelphesPileUpReader.h \
+	external/ExRootAnalysis/ExRootResult.h \
+	external/ExRootAnalysis/ExRootFilter.h \
+	external/ExRootAnalysis/ExRootClassifier.h
+tmp/modules/VertexFinderDA4D.$(ObjSuf): \
+	modules/VertexFinderDA4D.$(SrcSuf) \
+	modules/VertexFinderDA4D.h \
 	classes/DelphesClasses.h \
 	classes/DelphesFactory.h \
@@ -998,4 +1047,5 @@
 	tmp/modules/PileUpJetID.$(ObjSuf) \
 	tmp/modules/PileUpMerger.$(ObjSuf) \
+	tmp/modules/RecoPuFilter.$(ObjSuf) \
 	tmp/modules/SimpleCalorimeter.$(ObjSuf) \
 	tmp/modules/StatusPidFilter.$(ObjSuf) \
@@ -1010,4 +1060,5 @@
 	tmp/modules/UniqueObjectFinder.$(ObjSuf) \
 	tmp/modules/VertexFinder.$(ObjSuf) \
+	tmp/modules/VertexFinderDA4D.$(ObjSuf) \
 	tmp/modules/VertexSorter.$(ObjSuf) \
 	tmp/modules/Weighter.$(ObjSuf)
@@ -1615,4 +1666,9 @@
 	tmp/external/tcl/tclVar.$(ObjSuf)
 
+modules/VertexFinderDA4D.h: \
+	classes/DelphesModule.h \
+	classes/DelphesClasses.h
+	@touch $@
+
 modules/TrackSmearing.h: \
 	classes/DelphesModule.h
@@ -1959,4 +2015,8 @@
 
 modules/BTagging.h: \
+	classes/DelphesModule.h
+	@touch $@
+
+modules/RecoPuFilter.h: \
 	classes/DelphesModule.h
 	@touch $@