Index: modules/Efficiency.cc
===================================================================
--- modules/Efficiency.cc	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
+++ modules/Efficiency.cc	(revision 91177222b80bfe45d68ba024d31cbc3a23f6d7a4)
@@ -95,5 +95,5 @@
 {
   Candidate *candidate;
-  Double_t pt, eta, phi, e;
+  Double_t pt, eta, phi, e, d0, dz, ctgTheta;
 
   fItInputArray->Reset();
@@ -106,7 +106,10 @@
     pt = candidateMomentum.Pt();
     e = candidateMomentum.E();
+    d0 = candidate->D0;
+    dz = candidate->DZ;
+    ctgTheta = candidate->CtgTheta;
 
     // apply an efficency formula
-    if(gRandom->Uniform() > fFormula->Eval(pt, eta, phi, e)) continue;
+    if(gRandom->Uniform() > fFormula->Eval(pt, eta, phi, e, d0, dz, ctgTheta)) continue;
 
     fOutputArray->Add(candidate);
Index: modules/ModulesLinkDef.h
===================================================================
--- modules/ModulesLinkDef.h	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
+++ modules/ModulesLinkDef.h	(revision 91177222b80bfe45d68ba024d31cbc3a23f6d7a4)
@@ -32,5 +32,4 @@
 #include "modules/ParticlePropagator.h"
 #include "modules/Efficiency.h"
-#include "modules/TrackEfficiency.h"
 #include "modules/IdentificationMap.h"
 #include "modules/EnergySmearing.h"
@@ -86,5 +85,4 @@
 #pragma link C++ class ParticlePropagator+;
 #pragma link C++ class Efficiency+;
-#pragma link C++ class TrackEfficiency+;
 #pragma link C++ class IdentificationMap+;
 #pragma link C++ class EnergySmearing+;
Index: modules/TrackEfficiency.cc
===================================================================
--- modules/TrackEfficiency.cc	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
+++ 	(revision )
@@ -1,118 +1,0 @@
-/*
- *  Delphes: a framework for fast simulation of a generic collider experiment
- *  Copyright (C) 2012-2014  Universite catholique de Louvain (UCL), Belgium
- *
- *  This program is free software: you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation, either version 3 of the License, or
- *  (at your option) any later version.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
- */
-
-/** \class TrackEfficiency
- *
- *  Selects candidates from the InputArray according to the Efficiency formula.
- *
- *  \author M. Selvaggi - CERN
- *
- */
-
-#include "modules/TrackEfficiency.h"
-
-#include "classes/DelphesClasses.h"
-#include "classes/DelphesFactory.h"
-#include "classes/DelphesLongFormula.h"
-
-#include "ExRootAnalysis/ExRootClassifier.h"
-#include "ExRootAnalysis/ExRootFilter.h"
-#include "ExRootAnalysis/ExRootResult.h"
-
-#include "TDatabasePDG.h"
-#include "TFormula.h"
-#include "TLorentzVector.h"
-#include "TMath.h"
-#include "TObjArray.h"
-#include "TRandom3.h"
-#include "TString.h"
-
-#include <algorithm>
-#include <iostream>
-#include <sstream>
-#include <stdexcept>
-
-using namespace std;
-
-//------------------------------------------------------------------------------
-
-TrackEfficiency::TrackEfficiency() :
-  fFormula(0), fItInputArray(0)
-{
-  fFormula = new DelphesLongFormula;
-}
-
-//------------------------------------------------------------------------------
-
-TrackEfficiency::~TrackEfficiency()
-{
-  if(fFormula) delete fFormula;
-}
-
-//------------------------------------------------------------------------------
-
-void TrackEfficiency::Init()
-{
-  // read TrackEfficiency formula
-
-  fFormula->Compile(GetString("EfficiencyFormula", "1.0"));
-
-  // import input array
-  fInputArray = ImportArray(GetString("InputArray", "ParticlePropagator/stableParticles"));
-  fItInputArray = fInputArray->MakeIterator();
-
-  // create output array
-
-  fOutputArray = ExportArray(GetString("OutputArray", "stableParticles"));
-}
-
-//------------------------------------------------------------------------------
-
-void TrackEfficiency::Finish()
-{
-  if(fItInputArray) delete fItInputArray;
-}
-
-//------------------------------------------------------------------------------
-
-void TrackEfficiency::Process()
-{
-  Candidate *candidate;
-  Double_t pt, eta, phi, e, d0, dz, ctgTheta;
-
-  fItInputArray->Reset();
-  while((candidate = static_cast<Candidate *>(fItInputArray->Next())))
-  {
-    const TLorentzVector &candidatePosition = candidate->Position;
-    const TLorentzVector &candidateMomentum = candidate->Momentum;
-    eta = candidatePosition.Eta();
-    phi = candidatePosition.Phi();
-    pt = candidateMomentum.Pt();
-    e = candidateMomentum.E();
-    d0 = candidate->D0;
-    dz = candidate->DZ;
-    ctgTheta = candidate->CtgTheta;
-
-    // apply an efficency formula
-    if(gRandom->Uniform() > fFormula->Eval(pt, eta, phi, e, d0, dz, ctgTheta)) continue;
-
-    fOutputArray->Add(candidate);
-  }
-}
-
-//------------------------------------------------------------------------------
Index: modules/TrackEfficiency.h
===================================================================
--- modules/TrackEfficiency.h	(revision 77e9ae1ec605f7c5f74c0c0d56c265999f4acfb0)
+++ 	(revision )
@@ -1,58 +1,0 @@
-/*
- *  Delphes: a framework for fast simulation of a generic collider experiment
- *  Copyright (C) 2012-2014  Universite catholique de Louvain (UCL), Belgium
- *
- *  This program is free software: you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation, either version 3 of the License, or
- *  (at your option) any later version.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
- */
-
-#ifndef TrackEfficiency_h
-#define TrackEfficiency_h
-
-/** \class TrackEfficiency
- *
- *  Selects candidates from the InputArray according to the Efficiency formula.
- *
- *  \author M. Selvaggi - CERN
- *
- */
-
-#include "classes/DelphesModule.h"
-
-class TIterator;
-class TObjArray;
-class DelphesLongFormula;
-
-class TrackEfficiency: public DelphesModule
-{
-public:
-  TrackEfficiency();
-  ~TrackEfficiency();
-
-  void Init();
-  void Process();
-  void Finish();
-
-private:
-  DelphesLongFormula *fFormula; //!
-
-  TIterator *fItInputArray; //!
-
-  const TObjArray *fInputArray; //!
-
-  TObjArray *fOutputArray; //!
-
-  ClassDef(TrackEfficiency, 1)
-};
-
-#endif