Index: external/ExRootAnalysis/ExRootClassifier.h
===================================================================
--- external/ExRootAnalysis/ExRootClassifier.h	(revision d97a18b5a667135c87cc34c82f7a3f8ee806bb42)
+++ external/ExRootAnalysis/ExRootClassifier.h	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
@@ -11,7 +11,5 @@
   virtual ~ExRootClassifier() {}
   virtual Int_t GetCategory(TObject *object) = 0;
-
 };
 
 #endif /* ExRootClassifier */
-
Index: external/ExRootAnalysis/ExRootConfReader.cc
===================================================================
--- external/ExRootAnalysis/ExRootConfReader.cc	(revision d97a18b5a667135c87cc34c82f7a3f8ee806bb42)
+++ external/ExRootAnalysis/ExRootConfReader.cc	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
@@ -14,10 +14,10 @@
 #include "TSystem.h"
 
+#include <fstream>
+#include <iomanip>
 #include <iostream>
-#include <iomanip>
-#include <fstream>
+#include <sstream>
+#include <stdexcept>
 #include <string>
-#include <stdexcept>
-#include <sstream>
 
 using namespace std;
@@ -186,5 +186,5 @@
 int ModuleObjCmdProc(ClientData clientData, Tcl_Interp *interp, int objc, Tcl_Obj *const objv[])
 {
-  ExRootConfReader *reader = static_cast<ExRootConfReader*>(clientData);
+  ExRootConfReader *reader = static_cast<ExRootConfReader *>(clientData);
 
   if(objc < 3)
@@ -203,5 +203,5 @@
     Tcl_ListObjAppendElement(interp, object, Tcl_NewStringObj("namespace", -1));
     Tcl_ListObjAppendElement(interp, object, Tcl_NewStringObj("eval", -1));
-    Tcl_ListObjAppendList(interp, object, Tcl_NewListObj(objc-2, objv+2));
+    Tcl_ListObjAppendList(interp, object, Tcl_NewListObj(objc - 2, objv + 2));
 
     return Tcl_GlobalEvalObj(interp, object);
@@ -215,5 +215,5 @@
 int SourceObjCmdProc(ClientData clientData, Tcl_Interp *interp, int objc, Tcl_Obj *const objv[])
 {
-  ExRootConfReader *reader = static_cast<ExRootConfReader*>(clientData);
+  ExRootConfReader *reader = static_cast<ExRootConfReader *>(clientData);
   stringstream fileName;
 
@@ -245,5 +245,5 @@
   if(fObject && TCL_OK != Tcl_GetIntFromObj(fTclInterp, fObject, &result))
   {
-    message << "parameter '"<< fName << "' is not an integer." << endl;
+    message << "parameter '" << fName << "' is not an integer." << endl;
     message << fName << " = " << Tcl_GetStringFromObj(fObject, 0);
     throw runtime_error(message.str());
@@ -260,5 +260,5 @@
   if(fObject && TCL_OK != Tcl_GetLongFromObj(fTclInterp, fObject, &result))
   {
-    message << "parameter '"<< fName << "' is not an long integer." << endl;
+    message << "parameter '" << fName << "' is not an long integer." << endl;
     message << fName << " = " << Tcl_GetStringFromObj(fObject, 0);
     throw runtime_error(message.str());
@@ -275,5 +275,5 @@
   if(fObject && TCL_OK != Tcl_GetDoubleFromObj(fTclInterp, fObject, &result))
   {
-    message << "parameter '"<< fName << "' is not a number." << endl;
+    message << "parameter '" << fName << "' is not a number." << endl;
     message << fName << " = " << Tcl_GetStringFromObj(fObject, 0);
     throw runtime_error(message.str());
@@ -290,5 +290,5 @@
   if(fObject && TCL_OK != Tcl_GetBooleanFromObj(fTclInterp, fObject, &result))
   {
-    message << "parameter '"<< fName << "' is not a boolean." << endl;
+    message << "parameter '" << fName << "' is not a boolean." << endl;
     message << fName << " = " << Tcl_GetStringFromObj(fObject, 0);
     throw runtime_error(message.str());
@@ -314,5 +314,5 @@
   if(fObject && TCL_OK != Tcl_ListObjLength(fTclInterp, fObject, &length))
   {
-    message << "parameter '"<< fName << "' is not a list." << endl;
+    message << "parameter '" << fName << "' is not a list." << endl;
     message << fName << " = " << Tcl_GetStringFromObj(fObject, 0);
     throw runtime_error(message.str());
@@ -329,5 +329,5 @@
   if(fObject && TCL_OK != Tcl_ListObjIndex(fTclInterp, fObject, index, &object))
   {
-    message << "parameter '"<< fName << "' is not a list." << endl;
+    message << "parameter '" << fName << "' is not a list." << endl;
     message << fName << " = " << Tcl_GetStringFromObj(fObject, 0);
     throw runtime_error(message.str());
Index: external/ExRootAnalysis/ExRootConfReader.h
===================================================================
--- external/ExRootAnalysis/ExRootConfReader.h	(revision d97a18b5a667135c87cc34c82f7a3f8ee806bb42)
+++ external/ExRootAnalysis/ExRootConfReader.h	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
@@ -21,5 +21,4 @@
 {
 public:
-
   ExRootConfParam(const char *name = 0, Tcl_Obj *object = 0, Tcl_Interp *interp = 0);
 
@@ -34,5 +33,4 @@
 
 private:
-
   const char *fName; //!
   Tcl_Obj *fObject; //!
@@ -42,5 +40,5 @@
 //------------------------------------------------------------------------------
 
-class ExRootConfReader : public TNamed
+class ExRootConfReader: public TNamed
 {
 public:
@@ -66,5 +64,4 @@
 
 private:
-
   const char *fTopDir; //!
 
@@ -77,3 +74,2 @@
 
 #endif
-
Index: external/ExRootAnalysis/ExRootFilter.cc
===================================================================
--- external/ExRootAnalysis/ExRootFilter.cc	(revision d97a18b5a667135c87cc34c82f7a3f8ee806bb42)
+++ external/ExRootAnalysis/ExRootFilter.cc	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
@@ -11,15 +11,15 @@
 #include "ExRootAnalysis/ExRootClassifier.h"
 
+#include "TObjArray.h"
 #include "TSeqCollection.h"
-#include "TObjArray.h"
 
 #include <iostream>
+#include <sstream>
 #include <stdexcept>
-#include <sstream>
 
 using namespace std;
 
-typedef map<Int_t, TObjArray*> TCategoryMap;
-typedef map<ExRootClassifier*, pair<Bool_t, TCategoryMap> > TClassifierMap;
+typedef map<Int_t, TObjArray *> TCategoryMap;
+typedef map<ExRootClassifier *, pair<Bool_t, TCategoryMap>> TClassifierMap;
 
 ExRootFilter::ExRootFilter(const TSeqCollection *collection) :
@@ -40,5 +40,5 @@
         itSubMap != itMap->second.second.end(); ++itSubMap)
     {
-      delete (itSubMap->second);
+      delete(itSubMap->second);
     }
   }
@@ -132,3 +132,2 @@
 
 //------------------------------------------------------------------------------
-
Index: external/ExRootAnalysis/ExRootFilter.h
===================================================================
--- external/ExRootAnalysis/ExRootFilter.h	(revision d97a18b5a667135c87cc34c82f7a3f8ee806bb42)
+++ external/ExRootAnalysis/ExRootFilter.h	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
@@ -14,5 +14,4 @@
 {
 public:
-
   ExRootFilter(const TSeqCollection *collection);
   ~ExRootFilter();
@@ -23,12 +22,9 @@
 
 private:
-
   const TSeqCollection *fCollection; //!
   TIterator *fIter; //!
 
-  std::map<ExRootClassifier*, std::pair<Bool_t, std::map<Int_t, TObjArray*> > > fMap; //!
-
+  std::map<ExRootClassifier *, std::pair<Bool_t, std::map<Int_t, TObjArray *>>> fMap; //!
 };
 
 #endif /* ExRootFilter */
-
Index: external/ExRootAnalysis/ExRootProgressBar.cc
===================================================================
--- external/ExRootAnalysis/ExRootProgressBar.cc	(revision d97a18b5a667135c87cc34c82f7a3f8ee806bb42)
+++ external/ExRootAnalysis/ExRootProgressBar.cc	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
@@ -14,6 +14,6 @@
 #include <iostream>
 
+#include <stdio.h>
 #include <string.h>
-#include <stdio.h>
 
 using namespace std;
@@ -46,5 +46,5 @@
   if(fEntries > 0)
   {
-    Int_t hashes = Int_t(Double_t(entry)/fEntries*fWidth);
+    Int_t hashes = Int_t(Double_t(entry) / fEntries * fWidth);
     if(hashes > fWidth) hashes = fWidth;
     if(hashes != fHashes)
@@ -53,5 +53,5 @@
       memset(fBar + hashes, '-', fWidth - hashes);
       fHashes = hashes;
-      fprintf(stderr, "** [%s] (%.2f%%)\r", fBar, Float_t(entry)/fEntries*100.0);
+      fprintf(stderr, "** [%s] (%.2f%%)\r", fBar, Float_t(entry) / fEntries * 100.0);
     }
   }
@@ -77,3 +77,2 @@
 
 //------------------------------------------------------------------------------
-
Index: external/ExRootAnalysis/ExRootProgressBar.h
===================================================================
--- external/ExRootAnalysis/ExRootProgressBar.h	(revision d97a18b5a667135c87cc34c82f7a3f8ee806bb42)
+++ external/ExRootAnalysis/ExRootProgressBar.h	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
@@ -7,5 +7,4 @@
 {
 public:
-
   ExRootProgressBar(Long64_t entries, Int_t width = 64);
   ~ExRootProgressBar();
@@ -15,5 +14,4 @@
 
 private:
-
   Long64_t fEntries, fEventCounter;
   Int_t fWidth;
@@ -23,7 +21,5 @@
 
   char *fBar; //!
-
 };
 
 #endif /* ExRootProgressBar */
-
Index: external/ExRootAnalysis/ExRootResult.cc
===================================================================
--- external/ExRootAnalysis/ExRootResult.cc	(revision d97a18b5a667135c87cc34c82f7a3f8ee806bb42)
+++ external/ExRootAnalysis/ExRootResult.cc	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
@@ -12,18 +12,18 @@
 #include "ExRootAnalysis/ExRootUtilities.h"
 
-#include "TROOT.h"
+#include "TCanvas.h"
+#include "TClass.h"
 #include "TFile.h"
-#include "TClass.h"
-#include "TStyle.h"
-#include "TCanvas.h"
-#include "TLegend.h"
-#include "TPaveText.h"
-#include "TPaveStats.h"
-#include "TList.h"
+#include "TFolder.h"
 #include "TH2.h"
 #include "THStack.h"
+#include "TLegend.h"
+#include "TList.h"
+#include "TObjArray.h"
+#include "TPaveStats.h"
+#include "TPaveText.h"
 #include "TProfile.h"
-#include "TObjArray.h"
-#include "TFolder.h"
+#include "TROOT.h"
+#include "TStyle.h"
 
 #include <iostream>
@@ -37,5 +37,6 @@
 //------------------------------------------------------------------------------
 
-ExRootResult::ExRootResult() : fCanvas(0), fFolder(0)
+ExRootResult::ExRootResult() :
+  fCanvas(0), fFolder(0)
 {
 }
@@ -45,5 +46,5 @@
 ExRootResult::~ExRootResult()
 {
-  set<TObject*>::iterator itPool;
+  set<TObject *>::iterator itPool;
   for(itPool = fPool.begin(); itPool != fPool.end(); ++itPool)
   {
@@ -68,5 +69,5 @@
   TFile *file = new TFile(fileName, "RECREATE");
   file->cd();
-  std::map<TObject*, PlotSettings>::iterator itPlotMap;
+  std::map<TObject *, PlotSettings>::iterator itPlotMap;
   for(itPlotMap = fPlotMap.begin(); itPlotMap != fPlotMap.end(); ++itPlotMap)
   {
@@ -123,5 +124,5 @@
   // gStyle->SetOptFit(101);
 
-  fCanvas = static_cast<TCanvas*>(gROOT->FindObject("c1"));
+  fCanvas = static_cast<TCanvas *>(gROOT->FindObject("c1"));
   if(fCanvas)
   {
@@ -154,5 +155,5 @@
   if(!plot) return;
 
-  std::map<TObject*, PlotSettings>::iterator itPlotMap = fPlotMap.find(plot);
+  std::map<TObject *, PlotSettings>::iterator itPlotMap = fPlotMap.find(plot);
   if(itPlotMap != fPlotMap.end())
   {
@@ -178,8 +179,8 @@
   if(plot->IsA()->InheritsFrom(TH1::Class()))
   {
-    histogram = static_cast<TH1*>(plot);
-  }
-
-  map<TObject*, PlotSettings>::iterator itPlotMap = fPlotMap.find(plot);
+    histogram = static_cast<TH1 *>(plot);
+  }
+
+  map<TObject *, PlotSettings>::iterator itPlotMap = fPlotMap.find(plot);
   if(itPlotMap != fPlotMap.end())
   {
@@ -224,5 +225,5 @@
   TCanvas *canvas = GetCanvas();
 
-  map<TObject*, PlotSettings>::iterator itPlotMap;
+  map<TObject *, PlotSettings>::iterator itPlotMap;
 
   for(itPlotMap = fPlotMap.begin(); itPlotMap != fPlotMap.end(); ++itPlotMap)
@@ -236,10 +237,10 @@
     if(object->IsA()->InheritsFrom(TH1::Class()))
     {
-      histogram = static_cast<TH1*>(object);
+      histogram = static_cast<TH1 *>(object);
     }
     else if(object->IsA()->InheritsFrom(THStack::Class()))
     {
-      stack = static_cast<THStack*>(object);
-      histogram = static_cast<TH1*>(stack->GetHists()->First());
+      stack = static_cast<THStack *>(object);
+      histogram = static_cast<TH1 *>(stack->GetHists()->First());
     }
 
@@ -271,5 +272,5 @@
     if(histogram)
     {
-      stats = static_cast<TPaveStats*>(histogram->FindObject("stats"));
+      stats = static_cast<TPaveStats *>(histogram->FindObject("stats"));
       if(stats)
       {
@@ -300,7 +301,7 @@
 
 TH1 *ExRootResult::AddHist1D(const char *name, const char *title,
-                             const char *xlabel, const char *ylabel,
-                             Int_t nxbins, Axis_t xmin, Axis_t xmax,
-                             Int_t logx, Int_t logy)
+  const char *xlabel, const char *ylabel,
+  Int_t nxbins, Axis_t xmin, Axis_t xmax,
+  Int_t logx, Int_t logy)
 {
   TH1F *hist = new TH1F(name, title, nxbins, xmin, xmax);
@@ -324,7 +325,7 @@
 
 TH1 *ExRootResult::AddHist1D(const char *name, const char *title,
-                             const char *xlabel, const char *ylabel,
-                             Int_t nxbins, const Float_t *bins,
-                             Int_t logx, Int_t logy)
+  const char *xlabel, const char *ylabel,
+  Int_t nxbins, const Float_t *bins,
+  Int_t logx, Int_t logy)
 {
   TH1F *hist = new TH1F(name, title, nxbins, bins);
@@ -348,7 +349,7 @@
 
 TProfile *ExRootResult::AddProfile(const char *name, const char *title,
-                                   const char *xlabel, const char *ylabel,
-                                   Int_t nxbins, Axis_t xmin, Axis_t xmax,
-                                   Int_t logx, Int_t logy)
+  const char *xlabel, const char *ylabel,
+  Int_t nxbins, Axis_t xmin, Axis_t xmax,
+  Int_t logx, Int_t logy)
 {
   TProfile *profile = new TProfile(name, title, nxbins, xmin, xmax);
@@ -372,8 +373,8 @@
 
 TH2 *ExRootResult::AddHist2D(const char *name, const char *title,
-                             const char *xlabel, const char *ylabel,
-                             Int_t nxbins, Axis_t xmin, Axis_t xmax,
-                             Int_t nybins, Axis_t ymin, Axis_t ymax,
-                             Int_t logx, Int_t logy)
+  const char *xlabel, const char *ylabel,
+  Int_t nxbins, Axis_t xmin, Axis_t xmax,
+  Int_t nybins, Axis_t ymin, Axis_t ymax,
+  Int_t logx, Int_t logy)
 {
   TH2F *hist = new TH2F(name, title, nxbins, xmin, xmax, nybins, ymin, ymax);
Index: external/ExRootAnalysis/ExRootResult.h
===================================================================
--- external/ExRootAnalysis/ExRootResult.h	(revision d97a18b5a667135c87cc34c82f7a3f8ee806bb42)
+++ external/ExRootAnalysis/ExRootResult.h	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
@@ -2,10 +2,10 @@
 #define ExRootResult_h
 
+#include "Gtypes.h"
 #include "Rtypes.h"
-#include "Gtypes.h"
 #include "TMath.h"
 
+#include <map>
 #include <set>
-#include <map>
 
 class TH1;
@@ -23,5 +23,4 @@
 
 public:
-
   ExRootResult();
   ~ExRootResult();
@@ -32,23 +31,23 @@
 
   TH1 *AddHist1D(const char *name, const char *title,
-                 const char *xlabel, const char *ylabel,
-                 Int_t nxbins, Axis_t xmin, Axis_t xmax,
-                 Int_t logx = 0, Int_t logy = 0);
+    const char *xlabel, const char *ylabel,
+    Int_t nxbins, Axis_t xmin, Axis_t xmax,
+    Int_t logx = 0, Int_t logy = 0);
 
   TH1 *AddHist1D(const char *name, const char *title,
-                 const char *xlabel, const char *ylabel,
-                 Int_t nxbins, const Float_t *bins,
-                 Int_t logx = 0, Int_t logy = 0);
+    const char *xlabel, const char *ylabel,
+    Int_t nxbins, const Float_t *bins,
+    Int_t logx = 0, Int_t logy = 0);
 
   TProfile *AddProfile(const char *name, const char *title,
-                       const char *xlabel, const char *ylabel,
-                       Int_t nxbins, Axis_t xmin, Axis_t xmax,
-                       Int_t logx = 0, Int_t logy = 0);
+    const char *xlabel, const char *ylabel,
+    Int_t nxbins, Axis_t xmin, Axis_t xmax,
+    Int_t logx = 0, Int_t logy = 0);
 
   TH2 *AddHist2D(const char *name, const char *title,
-                 const char *xlabel, const char *ylabel,
-                 Int_t nxbins, Axis_t xmin, Axis_t xmax,
-                 Int_t nybins, Axis_t ymin, Axis_t ymax,
-                 Int_t logx = 0, Int_t logy = 0);
+    const char *xlabel, const char *ylabel,
+    Int_t nxbins, Axis_t xmin, Axis_t xmax,
+    Int_t nybins, Axis_t ymin, Axis_t ymax,
+    Int_t logx = 0, Int_t logy = 0);
 
   THStack *AddHistStack(const char *name, const char *title);
@@ -62,10 +61,9 @@
   TCanvas *GetCanvas();
 
-  void PrintPlot(TObject *plot, const char *sufix = "",  const char *format = "eps");
+  void PrintPlot(TObject *plot, const char *sufix = "", const char *format = "eps");
 
   void SetFolder(TFolder *folder) { fFolder = folder; }
 
 private:
-
   struct PlotSettings
   {
@@ -79,12 +77,10 @@
   TCanvas *fCanvas; //!
 
-  std::set<TObject*> fPool; //!
+  std::set<TObject *> fPool; //!
 
-  std::map<TObject*, PlotSettings> fPlotMap; //!
+  std::map<TObject *, PlotSettings> fPlotMap; //!
 
   TFolder *fFolder; //!
-
 };
 
 #endif /* ExRootResult_h */
-
Index: external/ExRootAnalysis/ExRootTask.cc
===================================================================
--- external/ExRootAnalysis/ExRootTask.cc	(revision d97a18b5a667135c87cc34c82f7a3f8ee806bb42)
+++ external/ExRootAnalysis/ExRootTask.cc	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
@@ -11,13 +11,13 @@
 #include "ExRootAnalysis/ExRootConfReader.h"
 
-#include "TROOT.h"
 #include "TClass.h"
 #include "TFolder.h"
+#include "TROOT.h"
 #include "TString.h"
 
+#include <iomanip>
 #include <iostream>
-#include <iomanip>
+#include <sstream>
 #include <stdexcept>
-#include <sstream>
 
 static const char *const kINIT = "0";
@@ -144,5 +144,5 @@
 
   if(!cl) return 0;
- 
+
   if(!cl->InheritsFrom(ExRootTask::Class()))
   {
@@ -310,3 +310,2 @@
   return object;
 }
-
Index: external/ExRootAnalysis/ExRootTask.h
===================================================================
--- external/ExRootAnalysis/ExRootTask.h	(revision d97a18b5a667135c87cc34c82f7a3f8ee806bb42)
+++ external/ExRootAnalysis/ExRootTask.h	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
@@ -17,8 +17,7 @@
 class TFolder;
 
-class ExRootTask : public TTask
+class ExRootTask: public TTask
 {
 public:
-
   ExRootTask();
   virtual ~ExRootTask();
@@ -41,5 +40,5 @@
   ExRootTask *NewTask(const char *className, const char *taskName);
 
-  void Exec(Option_t* option);
+  void Exec(Option_t *option);
 
   int GetInt(const char *name, int defaultValue, int index = -1);
@@ -55,5 +54,4 @@
 
 protected:
-
   TFolder *GetFolder() const { return fFolder; }
   ExRootConfReader *GetConfReader() const { return fConfReader; }
@@ -63,5 +61,4 @@
 
 private:
-
   TFolder *fFolder; //!
   ExRootConfReader *fConfReader; //!
@@ -71,3 +68,2 @@
 
 #endif /* ExRootTask */
-
Index: external/ExRootAnalysis/ExRootTreeBranch.cc
===================================================================
--- external/ExRootAnalysis/ExRootTreeBranch.cc	(revision d97a18b5a667135c87cc34c82f7a3f8ee806bb42)
+++ external/ExRootAnalysis/ExRootTreeBranch.cc	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
@@ -11,12 +11,12 @@
 #include "ExRootAnalysis/ExRootTreeBranch.h"
 
+#include "TClonesArray.h"
 #include "TFile.h"
+#include "TString.h"
 #include "TTree.h"
-#include "TString.h"
-#include "TClonesArray.h"
 
 #include <iostream>
+#include <sstream>
 #include <stdexcept>
-#include <sstream>
 
 using namespace std;
@@ -28,6 +28,6 @@
 {
   stringstream message;
-//  cl->IgnoreTObjectStreamer();
-//  cl->BypassStreamer();
+  //  cl->IgnoreTObjectStreamer();
+  //  cl->BypassStreamer();
   fData = new TClonesArray(cl, fCapacity);
 
@@ -65,9 +65,14 @@
   if(fSize >= fCapacity)
   {
-    if(fCapacity < 10) fCapacity = 10;
-    else if(fCapacity < 30) fCapacity = 30;
-    else if(fCapacity < 100) fCapacity = 100;
-    else if(fCapacity < 250) fCapacity = 250;
-    else fCapacity *= 2;
+    if(fCapacity < 10)
+      fCapacity = 10;
+    else if(fCapacity < 30)
+      fCapacity = 30;
+    else if(fCapacity < 100)
+      fCapacity = 100;
+    else if(fCapacity < 250)
+      fCapacity = 250;
+    else
+      fCapacity *= 2;
 
     fData->ExpandCreateFast(fCapacity);
@@ -76,5 +81,5 @@
     fData->ExpandCreateFast(fSize);
   }
-  
+
   return fData->AddrAt(fSize++);
 }
@@ -89,3 +94,2 @@
 
 //------------------------------------------------------------------------------
-
Index: external/ExRootAnalysis/ExRootTreeBranch.h
===================================================================
--- external/ExRootAnalysis/ExRootTreeBranch.h	(revision d97a18b5a667135c87cc34c82f7a3f8ee806bb42)
+++ external/ExRootAnalysis/ExRootTreeBranch.h	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
@@ -19,5 +19,4 @@
 {
 public:
-
   ExRootTreeBranch(const char *name, TClass *cl, TTree *tree = 0);
   ~ExRootTreeBranch();
@@ -27,5 +26,4 @@
 
 private:
-
   Int_t fSize, fCapacity; //!
   TClonesArray *fData; //!
@@ -33,3 +31,2 @@
 
 #endif /* ExRootTreeBranch */
-
Index: external/ExRootAnalysis/ExRootTreeReader.cc
===================================================================
--- external/ExRootAnalysis/ExRootTreeReader.cc	(revision d97a18b5a667135c87cc34c82f7a3f8ee806bb42)
+++ external/ExRootAnalysis/ExRootTreeReader.cc	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
@@ -10,9 +10,9 @@
 #include "ExRootAnalysis/ExRootTreeReader.h"
 
+#include "TBranchElement.h"
+#include "TCanvas.h"
+#include "TClonesArray.h"
 #include "TH2.h"
 #include "TStyle.h"
-#include "TCanvas.h"
-#include "TClonesArray.h"
-#include "TBranchElement.h"
 
 #include <iostream>
@@ -51,5 +51,5 @@
   if(fChain->IsA() == TChain::Class())
   {
-    TChain *chain = static_cast<TChain*>(fChain);
+    TChain *chain = static_cast<TChain *>(fChain);
     if(chain->GetTreeNumber() != fCurrentTree)
     {
@@ -94,5 +94,5 @@
       if(branch->IsA() == TBranchElement::Class())
       {
-        TBranchElement *element = static_cast<TBranchElement*>(branch);
+        TBranchElement *element = static_cast<TBranchElement *>(branch);
         const char *className = element->GetClonesName();
         Int_t size = element->GetMaximum();
@@ -145,3 +145,2 @@
 
 //------------------------------------------------------------------------------
-
Index: external/ExRootAnalysis/ExRootTreeReader.h
===================================================================
--- external/ExRootAnalysis/ExRootTreeReader.h	(revision d97a18b5a667135c87cc34c82f7a3f8ee806bb42)
+++ external/ExRootAnalysis/ExRootTreeReader.h	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
@@ -10,15 +10,14 @@
  */
 
-#include "TROOT.h"
-#include "TNamed.h"
 #include "TChain.h"
 #include "TFile.h"
+#include "TNamed.h"
+#include "TROOT.h"
 
 #include <map>
 
-class ExRootTreeReader : public TNamed
+class ExRootTreeReader: public TNamed
 {
-public :
-
+public:
   ExRootTreeReader(TTree *tree = 0);
   ~ExRootTreeReader();
@@ -32,5 +31,4 @@
 
 private:
-
   Bool_t Notify();
 
@@ -38,5 +36,5 @@
   Int_t fCurrentTree; //! current Tree number in a TChain
 
-  typedef std::map<TString, std::pair<TBranch*, TClonesArray*> > TBranchMap;
+  typedef std::map<TString, std::pair<TBranch *, TClonesArray *>> TBranchMap;
 
   TBranchMap fBranchMap; //!
Index: external/ExRootAnalysis/ExRootTreeWriter.cc
===================================================================
--- external/ExRootAnalysis/ExRootTreeWriter.cc	(revision d97a18b5a667135c87cc34c82f7a3f8ee806bb42)
+++ external/ExRootAnalysis/ExRootTreeWriter.cc	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
@@ -11,12 +11,12 @@
 #include "ExRootAnalysis/ExRootTreeBranch.h"
 
+#include "TClonesArray.h"
+#include "TFile.h"
 #include "TROOT.h"
-#include "TFile.h"
 #include "TTree.h"
-#include "TClonesArray.h"
 
 #include <iostream>
+#include <sstream>
 #include <stdexcept>
-#include <sstream>
 
 using namespace std;
@@ -31,8 +31,8 @@
 ExRootTreeWriter::~ExRootTreeWriter()
 {
-  set<ExRootTreeBranch*>::iterator itBranches;
+  set<ExRootTreeBranch *>::iterator itBranches;
   for(itBranches = fBranches.begin(); itBranches != fBranches.end(); ++itBranches)
   {
-    delete (*itBranches);
+    delete(*itBranches);
   }
 
@@ -69,5 +69,5 @@
 void ExRootTreeWriter::Clear()
 {
-  set<ExRootTreeBranch*>::iterator itBranches;
+  set<ExRootTreeBranch *>::iterator itBranches;
   for(itBranches = fBranches.begin(); itBranches != fBranches.end(); ++itBranches)
   {
@@ -95,5 +95,5 @@
 
   tree->SetDirectory(fFile);
-  tree->SetAutoSave(10000000);  // autosave when 10 MB written
+  tree->SetAutoSave(10000000); // autosave when 10 MB written
 
   return tree;
Index: external/ExRootAnalysis/ExRootTreeWriter.h
===================================================================
--- external/ExRootAnalysis/ExRootTreeWriter.h	(revision d97a18b5a667135c87cc34c82f7a3f8ee806bb42)
+++ external/ExRootAnalysis/ExRootTreeWriter.h	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
@@ -19,8 +19,7 @@
 class ExRootTreeBranch;
 
-class ExRootTreeWriter : public TNamed
+class ExRootTreeWriter: public TNamed
 {
 public:
-
   ExRootTreeWriter(TFile *file = 0, const char *treeName = "Analysis");
   ~ExRootTreeWriter();
@@ -36,5 +35,4 @@
 
 private:
-
   TTree *NewTree();
 
@@ -44,5 +42,5 @@
   TString fTreeName; //!
 
-  std::set<ExRootTreeBranch*> fBranches; //!
+  std::set<ExRootTreeBranch *> fBranches; //!
 
   ClassDef(ExRootTreeWriter, 1)
@@ -50,3 +48,2 @@
 
 #endif /* ExRootTreeWriter */
-
Index: external/ExRootAnalysis/ExRootUtilities.cc
===================================================================
--- external/ExRootAnalysis/ExRootUtilities.cc	(revision d97a18b5a667135c87cc34c82f7a3f8ee806bb42)
+++ external/ExRootAnalysis/ExRootUtilities.cc	(revision 6455202899ab4afd733c9cc0b4d78dd392cbb843)
@@ -10,10 +10,10 @@
 #include "ExRootAnalysis/ExRootUtilities.h"
 
+#include "TChain.h"
+#include "TH1.h"
 #include "TROOT.h"
-#include "TH1.h"
-#include "TChain.h"
 
+#include <fstream>
 #include <iostream>
-#include <fstream>
 
 using namespace std;
@@ -74,3 +74,2 @@
 
 //------------------------------------------------------------------------------
-